unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,TeeProcs, TeeTree,TreeChildManagers,  TreeEd, ExtCtrls,
  TeCanvas,ComCtrls, Buttons ;

type
  TForm1 = class(TForm)
    Panel8: TPanel;
    BtReduce: TSpeedButton;
    BtExtend: TSpeedButton;
    BtTop: TSpeedButton;
    BtLeft: TSpeedButton;
    BtList: TSpeedButton;
    BtExplo: TSpeedButton;
    Track_X: TTrackBar;
    Track_Y: TTrackBar;
    Tree1: TTree;
    Tree2: TTree;
    procedure BtReduceClick(Sender: TObject);
    procedure BtExtendClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BtTopClick(Sender: TObject);
    procedure BtLeftClick(Sender: TObject);
    procedure BtListClick(Sender: TObject);
    procedure BtExploClick(Sender: TObject);
    procedure Track_YChange(Sender: TObject);
    procedure Track_XChange(Sender: TObject);
  private
    { Dclarations prives }
    ChildTop        : TTreeSideAlignChild;
    ChildLeft       : TTreeSideAlignChild;
    ChildList         : TTreeListViewAlignChild;
    ChildExplorateur : TTreeExplorerAlignChild;

    ChildEnCours :Tobject;

    Procedure TreePrepareManager(ATree:TTree;AChildManager:TObject);

    function TreeTraceNode(ATree:TTree;AChildManager:TObject):TTreeNodeShape;

    function TreeTraceExplorateur(ATree:TTree):TTreeNodeShape;
    function TreeTraceTop(ATree:TTree):TTreeNodeShape;
    function TreeTraceLeft(ATree:TTree):TTreeNodeShape;
    function TreeTraceListView(ATree:TTree):TTreeNodeShape;

    function TreeChangeMargin(ATree:TTree; AMarg_X,AMarg_Y:integer):integer;


  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

{======================================================

CREATE / DESTROY FORMS

======================================================}

procedure TForm1.FormCreate(Sender: TObject);
begin
  inherited;
     // Format le tree
    ChildExplorateur  :=TTreeExplorerAlignChild.Create;
    ChildTop          :=TTreeTopBottomAlignChild.Create;
    ChildLeft         :=TTreeLeftRightAlignChild.Create;
    ChildList         :=TTreeListViewAlignChild.Create;


    Tree1.AssignParent:=True;
    ChildEnCours := ChildExplorateur;

end;


{======================================================

  INTERFACE USER

======================================================}

procedure TForm1.BtExtendClick(Sender: TObject);
begin
  Tree1.FullExpandCollapse(True);
end;

procedure TForm1.BtReduceClick(Sender: TObject);
begin
  Tree1.FullExpandCollapse(False);
end;


procedure TForm1.BtExploClick(Sender: TObject);   //if I click two > bug !
begin
  ChildEnCours := ChildExplorateur;
  TreeTraceNode(Tree1,ChildEnCours);
end;


procedure TForm1.BtLeftClick(Sender: TObject);   //if I click two > bug !
begin
  ChildEnCours := ChildLeft;
  TreeTraceNode(Tree1,ChildEnCours);
end;


procedure TForm1.BtListClick(Sender: TObject);   //if I click two > bug !
begin
    ChildEnCours := ChildList;
    TreeTraceNode(Tree1,ChildEnCours);
end;



procedure TForm1.BtTopClick(Sender: TObject);     //if I click two > bug !
begin
   ChildEnCours := ChildTop;
   TreeTraceNode(Tree1,ChildEnCours);
end;



procedure TForm1.Track_XChange(Sender: TObject);           //Not result  !
begin
  TreeChangeMargin(Tree1,Track_X.Position,Track_Y.Position)

end;

procedure TForm1.Track_YChange(Sender: TObject);           //Not result  !
begin
  TreeChangeMargin(Tree1,Track_X.Position,Track_Y.Position)
end;


{======================================================

UTILS FUNCTION FOR TRACE AND PREPARE TREE

======================================================}


function TForm1.TreeTraceNode(ATree: TTree;AChildManager: TObject): TTreeNodeShape;
var i:integer;

begin
Try
result :=nil;
if ATree=nil then exit;

       // clear Tree befeore change
       ATree.Clear;
       ATree.Selected.ScrollToView := False;

       // Prepare child Manager Tree (Explorateur ; top ; Left or ListView  )
       TreePrepareManager(Atree,AChildManager);


       //trace With  spcific Child Manager
       if (ATree.GlobalFormat.ChildManager is TTreeExplorerAlignChild) then
        TreeTraceExplorateur(ATree)
      else if ATree.GlobalFormat.ChildManager is  TTreeTopBottomAlignChild then
        TreeTraceTop(ATree)
      else if ATree.GlobalFormat.ChildManager is  TTreeLeftRightAlignChild then
        TreeTraceLeft(ATree)
      else if ATree.GlobalFormat.ChildManager is  TTreeListViewAlignChild then
        TreeTraceListView(ATree);

       //final cosmetic


Except
  On e:Exception do Showmessage(E.Message);
End;
end;



procedure TForm1.TreePrepareManager(ATree: TTree; AChildManager: TObject);
begin
if ATree=nil then exit;
try
     // Typ de tree Explorateur ; top ; Left ; ListView      (The PB isn't ancestor common!!)
      if (AChildManager is TTreeExplorerAlignChild) then
        ATree.ChangeManager(AChildManager as TTreeExplorerAlignChild)
      else if AChildManager is TTreeTopBottomAlignChild then
        ATree.ChangeManager(AChildManager as TTreeTopBottomAlignChild)
      else if AChildManager is TTreeLeftRightAlignChild then
        ATree.ChangeManager(AChildManager as TTreeLeftRightAlignChild)
      else if AChildManager is TTreeListViewAlignChild then
        ATree.ChangeManager(AChildManager as TTreeListViewAlignChild);

       ATree.invalidate;
Except
  On e:Exception do Showmessage(E.Message);
End;
end;



function TForm1.TreeTraceExplorateur(ATree: TTree): TTreeNodeShape;
var i:integer;
begin
  // Add 100 sample nodes
  with ATree.AddRoot('Root') do begin
    ImageIndex:=tiNone;
    Font.Color:=clBlue;
    Font.Style:=[fsBold];
    Expanded:=True;

    with AddChild('a') do begin
      AddChild('1');
      AddChild('2');
    end;
  end;
end;

function TForm1.TreeTraceLeft(ATree: TTree): TTreeNodeShape;
begin
  // Code Example Demo TeeTree:


  with ATree.AddRoot('Start') do
  begin
    Width:=30;
    Height:=30;
    X0:=15;
    Y0:=(ATree.Height div 2)+15;

    Style:=tssRectangle;
    Color:=clLime;
    Border.Color:=clRed;
    Border.Width:=2;
    Border.EndStyle:=esFlat;
    ImageIndex:=tiNone;
    Font.Color:=clBlue;
    Font.Style:=[fsBold];
    Expanded:=True;

    with AddChild('a') do
    begin
      Color:=clAqua;
      AddChild('1').Style:=tssCircle;
      AddChild('2').Style:=tssDiamond;
      with AddChild('3') do
      begin
        Style:=tssTriangleBottom;
        with AddChild('abc') do
        begin
          Style:=tssRoundRectangle;
          Color:=clRed;
          Border.Color:=clYellow;
          Font.Color:=clWhite;
        end;
        AddChild('def').Style:=tssRectangle;
      end;
    end;

    AddChild('b');
    AddChild('c');
    AddChild('d');
    AddChild('e');
  end;
  with ATree.HotTrack do
  begin
    Active:=True;
    UseFont:=True;
    Font.Size:=12;
    Border.Width:=2;
    Border.EndStyle:=esFlat;
    UseBorder:=True;
  end;
end;

function TForm1.TreeTraceListView(ATree: TTree): TTreeNodeShape;
var i:integer;
begin
   // // Code Example Demo TeeTree:

  for i:=0 to 99 do
      Tree1.Add('Node '+IntToStr(I));

  // Cosmetic
  Tree1.GlobalFormat.Border.Visible:=False;

  // Select first node:
  Tree1[0].Selected:=True;

end;


function TForm1.TreeTraceTop(ATree: TTree): TTreeNodeShape;
begin
   ATree.AssignParent:=True;

  // Code Example Demo TeeTree:

  with ATree.AddRoot('Start') do
  begin
    Width:=30;
    Height:=30;
    X0:=(ATree.Width div 2)-15;
    Y0:=15;
    Style:=tssRectangle;
    Color:=clLime;
    Border.Color:=clRed;
    Border.Width:=2;
    Border.EndStyle:=esFlat;
    ImageIndex:=tiNone;
    Font.Color:=clBlue;
    Font.Style:=[fsBold];
    Expanded:=True;

    with AddChild('a') do
    begin
      Color:=clAqua;
      AddChild('1').Style:=tssCircle;
      AddChild('2').Style:=tssDiamond;
      with AddChild('3') do
      begin
        Style:=tssTriangleBottom;
        with AddChild('abc') do
        begin
          Style:=tssRoundRectangle;
          Color:=clRed;
          Border.Color:=clYellow;
          Font.Color:=clWhite;
        end;
        AddChild('def').Style:=tssRectangle;
      end;
    end;

    AddChild('b');
    AddChild('c');
    AddChild('d');
    AddChild('e');
  end;
  with ATree.HotTrack do begin
    Active:=True;
    UseFont:=True;
    Font.Size:=12;
    Border.Width:=2;
    Border.EndStyle:=esFlat;
    UseBorder:=True;
  end;
end;

function TForm1.TreeChangeMargin(ATree: TTree; AMarg_X,AMarg_Y: integer): integer;
begin
   //change  margin property X et Y , but is not common anctor!!) >> not result ?
 if ATree.GlobalFormat.ChildManager is TTreeExplorerAlignChild then begin
     (ATree.GlobalFormat.ChildManager As TTreeExplorerAlignChild).HorizMargin := AMarg_X;
     (ATree.GlobalFormat.ChildManager As TTreeExplorerAlignChild).VertMargin := AMarg_Y;
 end
 else if ATree.GlobalFormat.ChildManager is TTreeTopBottomAlignChild then begin
     (ATree.GlobalFormat.ChildManager As TTreeTopBottomAlignChild).HorizMargin := AMarg_X;
     (ATree.GlobalFormat.ChildManager As TTreeTopBottomAlignChild).VertMargin := AMarg_Y;
  end
 else if ATree.GlobalFormat.ChildManager is TTreeLeftRightAlignChild then begin
     (ATree.GlobalFormat.ChildManager As TTreeLeftRightAlignChild).HorizMargin := AMarg_X;
     (ATree.GlobalFormat.ChildManager As TTreeLeftRightAlignChild).VertMargin := AMarg_Y;
  end
 else if ATree.GlobalFormat.ChildManager is TTreeListViewAlignChild then begin
     (ATree.GlobalFormat.ChildManager As TTreeListViewAlignChild).HorizMargin := AMarg_X;
     (ATree.GlobalFormat.ChildManager As TTreeListViewAlignChild).VertMargin := AMarg_Y;
 end;

  ATree.Invalidate;
end;

end.
